/* 
 * Mach Operating System
 * Copyright (c) 1991,1990,1989 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS 
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	cdrom_globs.h,v $
 * Revision 2.2  93/05/31  16:02:58  mrt
 * 	RCS-ed.
 * 	[93/05/08            af]
 * 
 */
/*
 * Copyright (C) 1990 Regents of the University of California.
 * Permission to use, copy, and distribute verbatim copies of this
 * software and its documentation for any purpose and without fee is
 * hereby granted, provided that the above copyright notice appears in all
 * copies.  Permission is granted to copy and distribute modified versions
 * of this software under the conditions for verbatim copying, provided
 * that the entire resulting derived work is distributed under the terms
 * of a permission notice identical to this one.  The University of
 * California makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 */

/* shorthand */
# define rootwin(x)	RootWindow(XtDisplay(x), XtWindow(x))

/*
 * number of milliseconds to sleep between
 * checking to see what the current track
 * is.
 */
# define TIMER_PERIOD		((unsigned long) 250)

extern Widget		top_setup();
extern Widget		main_setup();

extern void		cb_cdrom_play();
extern void		cb_cdrom_pause();
extern void		cb_cdrom_stop();
extern void		cb_cdrom_rewind();
extern void		cb_cdrom_ff();
extern void		cb_cdrom_eject();
extern void		cb_cdrom_cycle();
extern void		cb_cdrom_quit();
extern void		cb_cdrom_shuffle();
extern void		cb_cdrom_scanf();
extern void		cb_cdrom_scanr();

extern void		cdrom_timer_on();
extern void		logo_setup();
extern void		button_setup();
extern void		top_start();
extern void		track_button_update();
extern void		timer_label_update();
extern void		pause_button_reset();
extern void		shuffle_button_set();
extern void		shuffle_button_reset();
extern void		leds_stop();
extern void		shuffle_setup();

extern int		cdrom_open();
extern int		cdrom_init();

extern unsigned char	shuffle_next_track();
extern unsigned char	shuffle_prev_track();

extern Boolean		display_timer;

extern XtAppContext	appc;

extern char		*file;

# if defined(notdef)
extern float		volbase;
# endif /* defined(notdef) */
