/* 
 * Mach Operating System
 * Copyright (c) 1991,1990,1989 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS 
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	main.c,v $
 * Revision 2.2  93/05/31  16:04:08  mrt
 * 	RCS-ed.
 * 	[93/05/08            af]
 * 
 */
/*
 * Copyright (C) 1990 Regents of the University of California.
 * Permission to use, copy, and distribute verbatim copies of this
 * software and its documentation for any purpose and without fee is
 * hereby granted, provided that the above copyright notice appears in all
 * copies.  Permission is granted to copy and distribute modified versions
 * of this software under the conditions for verbatim copying, provided
 * that the entire resulting derived work is distributed under the terms
 * of a permission notice identical to this one.  The University of
 * California makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 */

# include <stdio.h>

# include <X11/Intrinsic.h>
# include <X11/StringDefs.h>

# include "debug.h"
# include "cdrom_globs.h"

void
main(argc, argv)
	int		argc;
	char		**argv;
{
	static void	chk_debug();
	Widget		top_form;

	chk_debug(argc, argv);

	if (cdrom_open() == -1)
		exit(1); /* perhaps a bit drastic */

	top_form = top_setup(argc, argv);

	logo_setup(top_form);

	button_setup(top_form);

	top_start();

	XtAppMainLoop(appc);

	exit(0);
}

static void
chk_debug(argc, argv)
	int	argc;
	char	**argv;
{
	int	i;

	/* ugly hack */
	for (i = 1; i < argc; i++) {
		if (strcmp(argv[i], "-debug") == 0) {
			debug = True;
			break;
		}
	}
}

void
usage() {
	(void) fprintf(stderr, "usage: xcdplayer [-debug]\n");

	exit(1);
}
